
/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.1                                        03/01/95 */
/*                                                                      */
/* AUTHORS: William C. Brown and Gerry A. Graesser                      */
/* VERSION: 1.1 (beta)                                                  */
/* DESCRIPTION: UWdialer call record (log) function(s).                 */
/*									*/
/*                                                                ----- */

#include <stdio.h>
#include <stropts.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/time.h>
#include <signal.h>
#include <ctype.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/OpenLook.h>
#include <Xol/ScrollingL.h>
#include <varargs.h>
#include <stropts.h>
#include <termio.h>
#include <dial.h>
#include "uwdialer.h"

char CallRecordFile[MAXPATHLEN];

time_t Connect_Time = 0;

void Call_Record(int Dial_Result_Code)
{
	extern char Logname[];
	extern char InitModemLine[];
	extern CALL call;
	FILE	*callrec_fp;
	time_t	connect_time, current_time;
	time_t	duration, hours, minutes, seconds;
	char	*Telno, *Disposition;
	int	rc;

	connect_time = Connect_Time;
	Connect_Time = 0;

	if (connect_time == 0)
		return;

	if (CallRecordFile[0] == 0)
		return;

	current_time = time(NULL);

	if (call.telno != NULL) {
		Telno = call.telno;
	} else {
		Telno = "";
	}

	if (Dial_Result_Code == 0) {
		Disposition = "connected";
	} else if (Dial_Result_Code == NO_ANS) {
		Disposition = "no answer";	/* caller script failed */
	} else if (Dial_Result_Code == INTRPT) {
		Disposition = "interrupt";
	} else {
		/* don't log dialer errors */
		return;
	}

	duration = current_time - connect_time;
	
	hours = duration / 3600;
	minutes = (duration % 3600) / 60;
	seconds = duration % 60;

	callrec_fp = fopen(CallRecordFile, APPEND);

	if (callrec_fp == NULL) {
		(void)DialerError(NONFATAL, OPENFAILCREC, CallRecordFile);
		return;
	}

	rc = fprintf(callrec_fp, "%-10s %-10s %-15s %20.20s %-10s %02d:%02d:%02d\n",
		Logname, InitModemLine, Telno, ctime(&connect_time),
		Disposition, hours, minutes, seconds);

	if (rc <= 0) {
		(void)DialerError(NONFATAL, WRITEFAILCREC, CallRecordFile);
	}

	(void)fclose(callrec_fp);
}

