
/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.1                                        03/01/95 */
/*                                                                      */
/* AUTHORS: William C. Brown and Gerry A. Graesser                      */
/* VERSION: 1.1 (beta)                                                  */
/* DESCRIPTION: Miscellaneous defines.					*/
/*									*/
/*                                                                ----- */

#define	FATAL		0x01
#define	NONFATAL	0x02
#define	LARGE		0x03
#define	SMALL		0x04
#define	MANUAL		0x05
#define SYSTEMS		0x06
#define	PERSONAL	0x07
#define	SYSTEM		0x08
#define	INIT		0x09
#define	START		0x0a
#define	RESET		0x0b
#define	RUN		0x0c
#define	MODIFY		0x0d
#define	DELETE		0x0e
#define	TERMINAL	0x0f
#define	XTERM		0x10
#define	ON		0x11
#define	OFF		0x12
#define TINY		0x13

#define	HELP		0x15
#define	MODEM		0x16
#define	NULLMODEMKEY	0x80

#define	UPLOAD		0x18
#define	DOWNLOAD	0x19
#define	REWRITE		0x1b
#define	LOCALCOMMAND	0x1c
#define	REMOTECOMMAND	0x1d

#define	PERSONAL_FILE	".uwdialer_systems"

#define	PADDING		20

#define	COMMENT		0x23	/* #       */
#define	NEWLINE		0x0a	/* newline */
#define	RETURN		0x0d    /* carrige return */
#define	TAB		0x09	/* tab     */
#define	SPACE		0x20	/* space   */
#define	READ		"r"
#define	WRITE		"w"
#define	APPEND		"a"
#define	READWRITE	"r+"

#define	MAXLOGNAMELEN	32	/* no longer restricted to 8 character limit ? */

/* Protocol {Button] Definitions */
#define	ASCII		0
#define	PROTO_NUM	10
#define	PROCMDLEN	80
#define	PROLABLEN	16	/* Keep in sync with Init_Proto() !!! */

extern	char	Proto_Label[PROTO_NUM][PROLABLEN];
extern	char	Transmit_Cmd[PROTO_NUM][PROCMDLEN];
extern	char	Receive_Cmd[PROTO_NUM][PROCMDLEN];

/* -----							*/
/* Error message defines.					*/
/*							  ----- */

#define	COLORALLOCATION	"Color allocation of color <%s> failed.\r\n"
#define FONTALLOCATION  "Font allocation of font <%s> failed.\r\n"
#define	MISSINGSYSTEM	"No system or line provided, dial fails.\r\n"
#define BLANKFIELD	"%s must contain at least one alphanumeric character.\r\n"
#define SEMICOLON	"%s cannot contain semi-colon (;) characters.\r\n"
#define	DIALFAILS	"Dial failed, errno = %d, msg = %s\r\n"
#define	OUTOFMEMORY	"System out of memory resource.\r\n"
#define	CREATEPERSONAL	"Failed to create personal system file <%s>.\r\n"
#define	CREATECALLREC	"Failed to create call record file <%s>.\r\n"
#define	PERSONALFILE	"No personal system file detected <%s>.\r\n"
#define	SYSTEMFILE	"Can't access UUCP Systems file.\r\n"
#define	NOITEMSELECTED	"No system selected in scrolling list.\r\n"
#define	ZEROREAD	"Zero characters read at modem.\r\n"
#define	CANTOPENLOCKDIR	"Can't open UUCP locks directory, restart uwdialer.\r\n"
#define	CANTGETCWD	"Can't get current working directory, restart uwdialer.\r\n"
#define	CANTGETPWD	"Can't get password file entry, UID = <%d>.\r\n"
#define	NONUSER		"Can't get password file entry, login = <%s>.\r\n"
#define	NOACCESSDIR	"Access denied, directory = <%s>.\r\n"
#define	NOACCESSLOG	"No write permission, directory = <%s>.\r\n"
#define	NOACCESSPER	"No write permission for personal systems file = <%s>.\r\n"
#define	NOACCESSCREC	"No write permission for call record file = <%s>.\r\n"
#define	OPENFAILCREC	"Failure opening call record file = <%s>.\r\n"
#define	WRITEFAILCREC	"Failure writing call record file = <%s>.\r\n"
#define	BADMODEMKEY	"Invalid Xdefault resource for initModemKey = <%s>.\r\n"
#define	NOMODEMKEY	"No Xdefault resource defined for initModemKey.\r\n"
#define NOMODEMTTY	"TTY name for the previous connection is not available.\r\n"
#define NOTTYDEV	"Can't get major/minor device numbers for TTY = <%s>.\r\n"
#define NOMODEMDEV	"No device for TTY = <%s> with \"initModemKey\" = <%c>.\r\n"
#define	NOTTYNAME	"Can't get TTY device name for the current connection.\r\n"
#define	CANTCHDIR	"Can't change working directory <%s>.\r\n"
#define	CANTOPENLOCK	"Can't open lock file <%s>.\r\n"
#define	OPENFORSAVE	"Can't open personal systems file <%s>.\r\n"
#define	TARGETFILE	"Can't open temporary file in /tmp.\r\n"
#define	WRITETARGET	"Trouble writing temporary file.\r\n"
#define	WRITEPERSONAL	"Trouble writing personal systems file <%s>.\r\n"
#define	BADSYSTEMSLIST	"No token found in current system list.\r\n"
#define	LOGGEROPENFAIL	"Failed to open requested log file <%s>.\r\n"
#define	NOLOGGERFILE	"No log file entered.\r\n"
#define	LOGALREADYON	"Session log already active.\r\n"
#define	NOTCONNECTED	"No active session.\r\n"
#define	NOXFERCHILD	"No active upload/download command.\r\n"
#define	CANTCREATECHILD	"Fork failed during transfer setup.\r\n"
#define	FILESPECIFIED	"Command doesn't use specified source or target file.\r\n"
#define	NOFILESPECIFIED "No source or target file specified.\r\n"
#define	ALREADYCONNECT  "Already connected to a remote system.\r\n"
#define	PROTOBUFWRFAIL	"Failed to write proto buf to parent.\r\n"
#define	PROTOIOCTL	"Failed to send filedescriptor to parent.\r\n"
#define	STREAMPIPERROR	"Error on stream pipe from child.\r\n"
#define	SERVERTERM	"Server terminated transmitting modem fd.\r\n"
#define	FORMATERROR	"Formatting error in fd transfer protocol.\r\n"
#define	OPENPIPEFAILED	"Failed to open pipe between parent and child.\r\n"
#define	STATLOCKFILE	"Failed to stat UUCP LCK file <%s>, errno <%d>.\r\n"
#define	CREATTMPLOCK	"Failed to create UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	WRITETMPLOCK	"Failed to write UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	CHMODTMPLOCK	"Failed to chmod UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	CHOWNTMPLOCK	"Failed to chown UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	CLOSETMPLOCK	"Failed to close UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	RENAMTMPLOCK	"Failed to rename UUCP LTMP file <%s>, errno <%d>.\r\n"
#define	ASCIIDOWNLOAD	"Failed to open ASCII download target file, <%s>\r\n"
#define	ASCIIUPLOAD	"Failed to open ASCII upload file, <%s>\r\n"
#define NOLOCALTERMINAL "Failed to open /dev/ptmx clone device.\r\n"
#define NOGRANT		"Failed to grant open permissions to master term.\r\n"
#define NOUNLOCK	"Failed to unlock slave filedescriptor.\r\n"
#define SLAVEOPEN	"Failed to open slave tty.\r\n"
#define IOCTLFAILED	"Failed to push STREAM module on STREAM. \r\n"

#define	TTY_SYS_NAME_MAX	15	/* Maximum TTY device or system name length */

typedef struct {
	int	Speed;
	int	CharSize;
	int 	Flow;
	int	Parity;
	char	*Line;
	char	*System;
} Dial_Info;

struct sys {
	char System[BUFSIZ];
	char Phone[BUFSIZ];
	char Speed[10];
	char CharSize[10];
	char Parity[10];
	char Flow[10];
	OlListToken token;
	struct sys *next;
};

enum xfer_msgs {
NULL_MSG,
UPLOAD_MSG,
DOWNLOAD_MSG,
LOCAL_UP_MSG,
LOCAL_DOWN_MSG,
LOCAL_CMD_MSG,
XFER_MSGS	/* Number of transfer messages - MUST BE LAST ENTRY */
};

extern enum xfer_msgs Xfer_Message;

/*
 * Enumerated list of control panel buttons that can be
 * set busy (True) or idle (False) via Set_Buttons()
 *
 * WARNING: The individual button definitions depend on the
 *	    button ordering in But_Items[] in uwdialer.c 
 */
enum dial_buttons {
SET_QUIT,
SET_SYSTEMS,
SET_MANUAL,
SET_FOCUS,
SET_HELP,
SET_HANGUP,
SET_MODEM,
SET_BREAK,
SET_LOG,
SET_UPLOAD,
SET_DOWNLOAD,
SET_TERMINATE,
DIAL_BUTTONS	/* Number of Logical Buttons - MUST BE LAST ENTRY */
};

/*
 * Enumerated list of the different subsets
 * of dial buttons that are used together
 * since there is not enought room for all
 * of the buttons to be displayed together.
 */
enum button_sets {
INITIAL_SET,
CONNECT_SET,
TRANSFER_SET,
BUTTON_SETS	/* Number of Subsets - MUST BE LAST ENTR?Y */
};

/* Number of Physical Buttons */
#define	MAIN_BUTTONS	6

/* Number of Buttons per Row */
#define	BUTTON_COLUMNS	3

/* Max Label Length including EOS */
#define	DIAL_LABEL_LEN	16

extern	const char Button_Label[DIAL_BUTTONS][DIAL_LABEL_LEN];
extern	const enum dial_buttons Button_Sets[BUTTON_SETS][MAIN_BUTTONS];

extern	char InitModemKey;

/* -----						*/
/* Prototypes.						*/
/*						  ----- */

void Call_Button(Widget, XtPointer, XtPointer),
     Call_Quit(Widget, XtPointer, XtPointer),
     Call_Manual(Widget, XtPointer, XtPointer),
     Call_Systems(Widget, XtPointer, XtPointer),
     Call_Hangup(Widget, XtPointer, XtPointer),
     Call_Modem(Widget, XtPointer, XtPointer),
     Call_Log(Widget, XtPointer, XtPointer),
     Call_Focus(Widget, XtPointer, XtPointer),
     Call_Help(Widget, XtPointer, XtPointer),
     Call_SndBrk(Widget, XtPointer, XtPointer),
     Call_Upload(Widget, XtPointer, XtPointer),
     Call_Downld(Widget, XtPointer, XtPointer),
     Call_Terminate(Widget, XtPointer, XtPointer);

void Call_Add(Widget, XtPointer, XtPointer);

void DialerError();
void Update_Connect_Clock(XtPointer, XtIntervalId *);
void Update_Display_Logger();
void Update_Display_Xfer(enum xfer_msgs);
void Display_Msg(Boolean, char *);
void Call_Record(int);
void Call_Repaint_Display(Widget, XEvent *, Region);
void Init_Proto();
void Init_Xterm();
void Install_Font(int, GC);
void Set_Speed(Widget, XtPointer, XtPointer);
void Set_Size(Widget, XtPointer, XtPointer);
void Set_Parity(Widget, XtPointer, XtPointer);
void Set_Flow(Widget, XtPointer, XtPointer);
void Call_Dial(Widget, XtPointer, XtPointer);
void Call_Save(Widget, XtPointer, XtPointer);
void Call_Disman(Widget, Widget, XtPointer);
void Call_Dismiss(Widget, Widget, XtPointer);
void Call_Systems(Widget, XtPointer, XtPointer);
void Set_Systems(Widget, XtPointer, XtPointer);
void Init_Dial(Dial_Info *, int);
void Init_Paths(void);
void Chars_At_Modem(XtPointer, int *, XtInputId *);
void Chars_At_Term(XtPointer, int *, XtInputId *);
void ReadFromLocalCommand(XtPointer, int *, XtInputId *);
void Settings(int);
void Call_Edit(Widget, XtPointer, XtPointer);
void Call_Delete(Widget, XtPointer, XtPointer);
void Delete_System(OlListToken);
void Edit_System_List();
void Set_Settings_Screen(char *);
void Modify_Systems(OlListToken, int);
void Insert_Modified_System(FILE *);
void Logger_Popup();
void Xfer_Popup(int);
void Complete_Connection(Dial_Info *, int *, XtInputId *);
void Set_Buttons(enum dial_buttons, int);
void Set_Labels(enum button_sets);
void Set_System_Buttons(int);
void Systems_Destroy(Widget, XtPointer, XtPointer);
void Systems_Dismiss(Widget, XtPointer, XtPointer);
void Sys_Dial(Widget, XtPointer, XtPointer);
void MyFree(struct sys *);
void DeleteItems(struct sys *);
void Construct_Dial_Struct(OlListToken);
void Call_Edit(Widget, XtPointer, XtPointer);
void Call_Delete(Widget, XtPointer, XtPointer);
void Delete_Lock(int, pid_t, pid_t);
void Init_Personal_File();
void Set_Protocol(Widget, XtPointer, XtPointer);
void Start_Xfer(Widget, XtPointer, XtPointer);
void Drop_Xfer(Widget, XtPointer, XtPointer);
void Receive_Ascii_File(char *);
void Transmit_Ascii_File(char *);
void StartLocalCommand(char *, char *);
void StartRemoteProtocol(char *, char *);

int ExpandPath(char *, char []);
int SetSpeed(struct sys *);
int SetFlow(struct sys *);
int SetCharSize(struct sys *);
int SetParity(struct sys *);
int Report_Speed(struct termios *);

char *Resolve_Dial_Error(int);

Pixel GetPixelByName(Widget, char *);
XtPointer CONVERT();

